LazyInitializer (Apache Commons Lang 3.17.0 API)
Description: declaration: package: org.apache.commons.lang3.concurrent, class: LazyInitializer

Package org.apache.commons.lang3.concurrent

# Class LazyInitializer<T>

java.lang.Object
org.apache.commons.lang3.concurrent.AbstractConcurrentInitializer<T,ConcurrentException>
org.apache.commons.lang3.concurrent.LazyInitializer<T>

Type Parameters:
  `T` - the type of the object managed by the initializer.

All Implemented Interfaces:
  `ConcurrentInitializer<T>`, `FailableSupplier<T,ConcurrentException>`

public class LazyInitializer<T> extends AbstractConcurrentInitializer<T,ConcurrentException>
This class provides a generic implementation of the lazy initialization pattern.

Sometimes an application has to deal with an object only under certain circumstances, e.g. when the user selects a specific menu item or if a special event is received. If the creation of the object is costly or the consumption of memory or other system resources is significant, it may make sense to defer the creation of this object until it is really needed. This is a use case for the lazy initialization pattern.

This abstract base class provides an implementation of the double-check idiom for an instance field as discussed in Joshua Bloch's "Effective Java", 2nd edition, item 71. The class already implements all necessary synchronization. A concrete subclass has to implement the `initialize()` method, which actually creates the wrapped data object.

As an usage example consider that we have a class `ComplexObject` whose instantiation is a complex operation. In order to apply lazy initialization to this class, a subclass of `LazyInitializer` has to be created:

     public class ComplexObjectInitializer extends LazyInitializer<ComplexObject> {
         &#064;Override
         protected ComplexObject initialize() {
             return new ComplexObject();
         }
     }

Access to the data object is provided through the `get()` method. So, code that wants to obtain the `ComplexObject` instance would simply look like this:

     // Create an instance of the lazy initializer
     ComplexObjectInitializer initializer = new ComplexObjectInitializer();
     ...
     // When the object is actually needed:
     ComplexObject cobj = initializer.get();

If multiple threads call the `get()` method when the object has not yet been created, they are blocked until initialization completes. The algorithm guarantees that only a single instance of the wrapped object class is created, which is passed to all callers. Once initialized, calls to the `get()` method are pretty fast because no synchronization is needed (only an access to a volatile member field).

Since:
  3.0

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `LazyInitializer.Builder<I extends LazyInitializer<T>,T>`
  Builds a new instance.

  ## Nested classes/interfaces inherited from class org.apache.commons.lang3.concurrent.AbstractConcurrentInitializer

  `AbstractConcurrentInitializer.AbstractBuilder<I extends AbstractConcurrentInitializer<T,E>,T,B extends AbstractConcurrentInitializer.AbstractBuilder<I,T,B,E>,E extends Exception>`

- ## Field Summary

  ### Fields inherited from interface org.apache.commons.lang3.function.FailableSupplier

  `NUL`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LazyInitializer()`
  Constructs a new instance.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static <T> LazyInitializer.Builder<LazyInitializer<T>,T>`
  `builder()`
  Creates a new builder.
  `T`
  `get()`
  Returns the object wrapped by this instance.
  `protected ConcurrentException`
  `getTypedException(Exception e)`
  Gets an Exception with a type of E as defined by a concrete subclass of this class.
  `boolean`
  `isInitialized()`
  Tests whether this instance is initialized.

  ### Methods inherited from class org.apache.commons.lang3.concurrent.AbstractConcurrentInitializer

  `close, initialize`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### LazyInitializer

    public LazyInitializer()
    Constructs a new instance.

- ## Method Details

  - ### builder

    public static <T> LazyInitializer.Builder<LazyInitializer<T>,T> builder()
    Creates a new builder.
    Type Parameters:
      `T` - the type of object to build.
    Returns:
      a new builder.
    Since:
      3.14.0

  - ### get

    public T get() throws ConcurrentException
    Returns the object wrapped by this instance. On first access the object is created. After that it is cached and can be accessed pretty fast.
    Returns:
      the object initialized by this `LazyInitializer`
    Throws:
      `ConcurrentException` - if an error occurred during initialization of the object

  - ### getTypedException

    protected ConcurrentException getTypedException(Exception e)
    Gets an Exception with a type of E as defined by a concrete subclass of this class.
    Specified by:
      `getTypedException` in class `AbstractConcurrentInitializer<T,ConcurrentException>`
    Parameters:
      `e` - The actual exception that was thrown
    Returns:
      a new exception with the actual type of E, that wraps e.

  - ### isInitialized

    public boolean isInitialized()
    Tests whether this instance is initialized. Once initialized, always returns true.
    Specified by:
      `isInitialized` in class `AbstractConcurrentInitializer<T,ConcurrentException>`
    Returns:
      whether this instance is initialized. Once initialized, always returns true.
    Since:
      3.14.0